启动代码扫描
curl --request POST \
--url https://api.devin.ai/v3/enterprise/organizations/{org_id}/code-scans \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"repo_name": "<string>",
"commit_sha": "<string>",
"host": "<string>",
"profile_id": "<string>"
}
'import requests
url = "https://api.devin.ai/v3/enterprise/organizations/{org_id}/code-scans"
payload = {
"repo_name": "<string>",
"commit_sha": "<string>",
"host": "<string>",
"profile_id": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
repo_name: '<string>',
commit_sha: '<string>',
host: '<string>',
profile_id: '<string>'
})
};
fetch('https://api.devin.ai/v3/enterprise/organizations/{org_id}/code-scans', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"created_at": 123,
"host": "<string>",
"org_id": "<string>",
"profile": {
"name": "<string>",
"profile_id": "<string>"
},
"repo_name": "<string>",
"scan_id": "<string>",
"scan_type": "security",
"status": "waiting"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}{
"status": 123,
"title": "<string>",
"detail": "<string>",
"errors": [
{}
],
"instance": "<string>",
"type": "about:blank"
}代码扫描(企业)
启动代码扫描(Devin API)
通过 v3 Enterprise API 在组织的代码仓库中启动新的 Devin 代码扫描,也可指定扫描配置或 commit
POST
/
v3
/
enterprise
/
organizations
/
{org_id}
/
code-scans
启动代码扫描
权限
UseAccountCodeScans 权限。
行为
repo_name 的新代码扫描加入队列。扫描调度程序会异步启动扫描;响应中返回扫描记录,其初始 status 为 waiting 或 pending。轮询 列出代码扫描 以跟踪进度,并在扫描状态变为 completed 后,通过 列出代码扫描发现项 (按 scan_id 过滤) 查看结果。
该扫描归属于调用主体 (即发出请求的服务用户或 PAT) 。
请求字段
repo_name(必填) :完整的代码仓库名称,例如owner/repo。该代码仓库必须已可通过组织的 Git 集成访问。host:代码仓库的 Git 主机 (如无法自动推断) 。profile_id:要应用的扫描 Profile。对于ingest模式的 Profile,请使用启动摄取扫描。scan_type:要运行的扫描类型。提供profile_id时,必须与该 Profile 的扫描类型一致。默认为 Profile 的类型;未指定 Profile 时,默认为security。非安全扫描类型必须指定 Profile。commit_sha:扫描前要检出的提交。默认为代码仓库默认分支的最新提交。
错误
- 当
scan_type与 Profile 不匹配,或未提供 Profile 却指定了非安全类scan_type时,返回400。 - 当组织仅允许仅摄取扫描,且未提供
ingest模式的 Profile 时,返回403。 - 当企业账户无权查看组织、代码仓库或 Profile 时,返回
404。 - 当组织的扫描待办列表已满时,返回
409。请稍后重试。
授权
服务用户凭据(前缀:cog_)
路径参数
组织 ID(前缀:org-)
示例:
"org-abc123def456"
请求体
application/json
用于启动新代码扫描的请求正文。
要扫描的代码仓库全名。
扫描前要检出的提交。
代码仓库的 Git 主机(如果已知)。
要应用于此次扫描的扫描 Profile。
要运行的扫描类型。指定 Profile 时必须与该 Profile 的扫描类型匹配;默认使用该 Profile 的类型,未指定 Profile 的扫描则默认为 'security'。非安全类型必须指定 Profile,否则会被拒绝。
可用选项:
security, performance, db-queries, test-coverage, dead-code, code-quality, telemetry, accessibility, general, migration-docs 响应
成功响应
一次代码扫描。
扫描的创建时间(Unix 秒)。
代码仓库的 Git 托管平台(如已知)。
该扫描所属的组织。
扫描所使用的 Profile(如有)。
Show child attributes
Show child attributes
扫描的主代码仓库。多代码仓库扫描还会涵盖此处未列出的其他代码仓库。
扫描的唯一标识符。
扫描类型,在创建时确定。
可用选项:
security, performance, db-queries, test-coverage, dead-code, code-quality, telemetry, accessibility, general, migration-docs 扫描状态:waiting、pending、running、awaiting_user_input、completed、failed 或 cancelled。
可用选项:
waiting, pending, running, awaiting_user_input, completed, failed, cancelled 
